local addonName, addonTable = ...
local childName = "zzMoney2"
local db, dbr, dbp, faction, realm, connectedRealms
addonTable['events']  = addonTable['events']  or {}
local events = addonTable['events'] 
local session = { start = 0,	income = 0,	expense = 0 }
local L = LibStub("AceLocale-3.0"):GetLocale(childName, true)
local function prepareDB()
	local player = UnitName('player')
	realm = GetNormalizedRealmName()
	if(not realm) then return end
	faction = UnitFactionGroup('player')
	local className, classFilename, classId = UnitClass('player')
	addonTable['db']['profile'][childName] = addonTable['db']['profile'][childName] or {}
	db = addonTable['db']['profile'][childName]
	db[realm] = db[realm] or {}
	db[faction] = db[faction] or {}
	db[faction]['banker'] = db[faction]['banker'] or {}
	db[faction]['banker']['banker'] = db[faction]['banker']['banker'] or player
	dbr = db[realm]
	dbr['activity'] = dbr['activity'] or { Horde = {}, Alliance={}}
	dbr['Horde'] = dbr['Horde'] or {}
	dbr['Alliance'] = dbr['Alliance'] or {}
	dbr[player] = dbr[player] or {}
	dbp = dbr[player]
	dbp['faction'] = faction
	dbp['currentGold'] = dbp['currentGold'] or 0
	dbp['class'] = classFilename
	dbp['faction'] = faction
	addonTable['storage'] = {
		['db'] = db,
		['dbr'] = dbr,
		['dbp'] = dbp,
		['dbf'] = db[faction],
		['L'] = L,
		['session'] = session,
		['faction'] = faction,
		['realm'] = realm,
	}
	addonTable:SetupPrefs(childName)
	addonTable:SetupBroker()
	addonTable:SetupBanker()
end
function addonTable:getDateString()
	return format("%s%s",tostring(date("%Y")),tostring(1000 + date("%j")))
end
local specs  = {
	['name'] = childName,
	['sv'] = true,
	['cfg'] = true,
	['cfgReset'] = prepareDB,
	['ldb'] = addonTable['ldb'] ,
	['defaults'] = {
		['profile'] = {
			[childName] = {
				['disableBanker'] = true,
			}
		}
	}
}
function addonTable:displayMoney(money, abr)
	if(abr) then
		local ab = false
		if(db['abrevM'] and money >= 10000000000) then
			ab = L['abrM']
			money = addonTable:round(money / 10000000000,1) * 10000
		elseif(db['abrevK'] and money >= 10000000) then
			ab = L['abrK']
			money = addonTable:round(money / 10000000,1) * 10000
		end
		if(ab) then
			 if(db['shortMoney'] and money>10000)then
				money = addonTable:round(money / 10000,0) * 10000
			end
			return gsub(GetCoinTextureString(money), "(%d+)", function(num) return format('%i%s',num, ab) end,1)
		end
	end
	if(db['shortMoney'] and money>10000)then
		money = addonTable:round(money / 10000,0) * 10000
	end
	return GetCoinTextureString(money)
end
local pew_events = {}
function pew_events:PLAYER_MONEY(event)
	local money = GetMoney()
	if(money == 0) then  return end
	if(session['start'] == 0) then
		session['start'] = money
	end
	dbp['currentGold'] = dbp['currentGold'] or 0
	dbp['incoming'] = 0
	if(money ~= dbp['currentGold']) then
		local diff = money - dbp['currentGold']
		local out = GetCoinTextureString(abs(diff))
		local color = "ffffff"
		local stamp = time()
		local day = addonTable:getDateString()
		local dba = dbr['activity'][faction]
		dba[day] = dba[day] or {}
		local dbd = dba[day]
		while(dbd[stamp]) do
			stamp = stamp + 1
		end
		if(diff < 0) then
			color = "ff0000"
			session['expense'] = session['expense'] + diff
		else
			session['income'] = session['income'] + diff
		end
		dbd[stamp] = diff
		if(db['showLog']) then
			print(addonTable:colorize(out, color))
		end
		dbp['currentGold'] = money
	end
	addonTable:OnText(childName, addonTable:displayMoney(money, true))
end
function addonTable:PrefChanged(pref, value, oldvalue)
	pew_events:PLAYER_MONEY()
end
function events:PLAYER_ENTERING_WORLD(event)
	addonTable['db']['profile'][childName ] = addonTable['db']['profile'][childName] or {}
	db = addonTable['db']['profile'][childName]
	prepareDB()
	addonTable:UnregisterEvent('PLAYER_ENTERING_WORLD')
	addonTable:RegisterEvent(pew_events)
	pew_events:PLAYER_MONEY()
end
LibStub:GetLibrary("zzAddOn"):NewAddOn(specs, ...)

